#-*-coding:utf-8-*-
from posh.thumbs.initthumbs import DB
from posh.logger.logger import log
TABQUERY = "SELECT name,seq,type,param,id FROM profile WHERE user_id='%s' AND id='%s' "

isdebug=True

def debug(msg, loglevel=0):
    if type(msg) != str:
        msg = str(msg)
    if isdebug:
        log("Exportthumbs.py : %s" % msg, loglevel)

class ExportThumbs(DB):
    """ exportateur d'onglet """

    def __init__(self, username, session_pt, user_id, thumb_id, thumb_name, thumb_indice, xmlrpc_server, myip):
        """
            user_id : id de l'utilisateur admin dans la base
            thumb_id : id de l'onglet dans la base
            session_pt : pt du serveur cas pour le serveur de profil
            thumb_name : nom de l'onglet pour dans la base
            thumb_indice : son indice utilisé pour l'ordre des onglets dans la page du user
            xmlrpc_server : objet xmlrpclib.Server
            myip : ip du client de profil
        """
        debug("* Initialisation de la classe d'exportation")
        super(ExportThumbs, self).__init__()
        self.username = username
        self.session_pt = session_pt
        self.user_id = user_id
        self.thumb_id = thumb_id
        self.thumb_name = thumb_name
        self.thumb_indice = thumb_indice
        self.server = xmlrpc_server
        self.myip = myip

    def _get_thumb(self):
        """
            renvoie les données liées à l'onglet à exporter
        """
        debug("+ Récupération de l'onglet à exporter dans la base de posh")
        try:
            self.connect_db()
            query = TABQUERY % (self.user_id, self.thumb_id)
            debug(query)
            self.db.query(query)
            rows = self.db.store_result()
            tab = list(rows.fetch_row(0))

        except Exception, error:
            import traceback
            traceback.print_exc()
            log("- Erreur : récupération de la description de l'onglet dans la base de posh.")
            debug(error.message)
        self.close_db()
        try:
            result = list(tab[0])
        except Exception, error:
            debug(error.message)
            result = []
        # si l'indice doit être modifié
        try:
            if int(self.thumb_indice) >= 0:
                result[1] = self.thumb_indice
        except:
            debug("- Erreur : On essaye d'insérer un onglet dont l'indice n'est pas un nombre.")
        # on insère le nom pour dans la table de profil
        result.insert(0, self.thumb_name)
        debug("Description de l'onglet %s" % str(result), 1)
        return result

    def export_thumb(self):
        """
            exporte un onglet
        """
        thumb = self._get_thumb()
        try:
            return_str = self.server.export_thumb(self.username, self.session_pt, self.myip, self.thumb_name, thumb)
            return_str = return_str.encode('utf-8')
            debug("+ Le serveur de profil a renvoyé le message suivant : %s" % return_str)
        except Exception, error:
            traceback.print_exc()
            debug("- Erreur : échec de l'export d'onglet vers la base de profil")
            debug(error.message)
            return_str = ""
        return return_str
